=== debian/changelog ===
colmap (3.6+dev3+git20200516-1) unstable; urgency=medium

  * New upstream version.
  * Update build dependency. (Closes: #960784)
  * Bump standards version to 4.5.0.
  * Add Vcs fields.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sat, 16 May 2020 20:25:14 +0200
