=== lib/LSD/CMakeLists.txt ===
COLMAP_ADD_STATIC_LIBRARY(lsd
    lsd.h
    lsd.c
)
