=== debian/changelog ===
colmap (3.6+really3.6-1) unstable; urgency=medium

  * New upstream version. (Closes: #957094)
  * d/rules: run tests. (Closes: #909198)
  * d/upstream/metadata: added.
  * d/control: added Rules-Requires-Root.
  * d/copyright:
    - update copyright years.
    - added Upstream-Contact.
  * Bump debhelper version to 13, drop d/compat.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 01 Sep 2020 12:24:54 +0200
