=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: science
 Priority: optional
 Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
-Build-Depends: debhelper (>= 11), libeigen3-dev, libgoogle-glog-dev, libceres-dev, libqt5opengl5-desktop-dev, libfreeimage-dev, libglew-dev, cmake, libboost-system-dev, libboost-program-options-dev, libboost-filesystem-dev, libboost-regex-dev, libboost-test-dev, libboost-graph-dev
+Build-Depends: debhelper-compat (= 13), libeigen3-dev, libgoogle-glog-dev, libceres-dev, libqt5opengl5-desktop-dev, libfreeimage-dev, libglew-dev, cmake, libboost-system-dev, libboost-program-options-dev, libboost-filesystem-dev, libboost-regex-dev, libboost-test-dev, libboost-graph-dev
 Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/myczko-guest/colmap.git
 Vcs-Browser: https://salsa.debian.org/myczko-guest/colmap
+Rules-Requires-Root: no
 Homepage: https://github.com/colmap/colmap
 
 Package: colmap
