=== debian/changelog ===
colmap (3.6+really3.6+git20210519-2build2) jammy; urgency=medium

  * No-change rebuild against libceres2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 19 Dec 2021 01:23:24 +0000

colmap (3.6+really3.6+git20210519-2build1) jammy; urgency=medium

  * No-change rebuild against libglew2.2

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 26 Oct 2021 13:11:29 +0000

colmap (3.6+really3.6+git20210519-2) unstable; urgency=medium

  * Upload to unstable.
  * d/colmap.install: apply patch to fix FTBFS on hurd-i386.
    Thanks Pino Toscano.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 04 Oct 2021 12:14:32 +0200

colmap (3.6+really3.6+git20210519-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 19 May 2021 16:04:27 +0200
